
import java.io.IOException;
import java.net.URL;
import java.util.zip.ZipInputStream;

import sdljava.SDLException;
import sdljava.ttf.SDLTrueTypeFont;
import sdljava.ttf.*;
import sdljava.video.SDLColor;
import sdljava.video.SDLRect;
import sdljava.video.SDLSurface;
import sdljava.x.swig.SDL_Surface;
import sdljava.x.swig.SWIGTYPE_p__TTF_Font;


public class Text {

	private static SDLSurface ttext;		//creamos variable para mostrar texto

	private SDLColor bgcolor,fgcolor; 	//crea objects para el color de las fonts del texto
	private sdljava.video.SDLColor transparent;

	
	private SDLTrueTypeFont font; 		//almacena el tipo de font

	private SWIGTYPE_p__TTF_Font font2;
	private sdljava.video.SDLRect rectangle;		//crea rectangle, para borrar antiguos frames y texto
	private String path;
	private int size; 
	
	
	
	public void Text() throws SDLException{
		
		//System.out.println("hola");
		
		//String name = "fonts/FreeSerif.ttf";
		
		//fgcolor = new SDLColor();
		
		fgcolor.setRed(255);		//establecemos colores de primer plano
		fgcolor.setGreen(255);
		fgcolor.setBlue(255);
		
		size = 20;
	/*	
		fgcolor.setRed(0);		//establecemos colores de primer plano
		fgcolor.setGreen(255);
		fgcolor.setBlue(255);
*/
		bgcolor.setRed(0);		//establecemos colores de segundo plano
		bgcolor.setGreen(0);
		bgcolor.setBlue(0);

		transparent.setRed(0);
		transparent.setGreen(255);
		transparent.setBlue(0);

		//font = sdljava.ttf.SDLTTF.openFont("fonts/FreeSerif.ttf", 20);//TTF_OpenFont(name,20); //cargamos la font
		
	}

	public void init(String name, int z) throws SDLException, IOException{
		
		path = name ;
	

		fgcolor = new SDLColor();
		
		fgcolor.setRed(255);		//establecemos colores de primer plano
		fgcolor.setGreen(255);
		fgcolor.setBlue(255);
	
		
		font = sdljava.ttf.SDLTTF.openFont( name, z);//TTF_OpenFont(name,20); //cargamos la font
		
	}
	public void init(String name) throws SDLException, IOException{
		
		//System.out.println("init1");
		
		path = name ;
		
		//System.out.println("init1.1");
		size = 20;
		
		//System.out.println("init1.2");
		

		fgcolor = new SDLColor();
		
		fgcolor.setRed(255);		//establecemos colores de primer plano
		fgcolor.setGreen(255);
		fgcolor.setBlue(255);
	
		
		/*
		System.out.println("init1.3");
		bgcolor.setRed(0);		//establecemos colores de segundo plano
		bgcolor.setGreen(0);
		bgcolor.setBlue(0);

		transparent.setRed(0);
		transparent.setGreen(255);
		transparent.setBlue(0);
*/
	
		/*
		System.out.println(this.getClass().getResource(name) ) ; //conversion de string a uri
		URL url = this.getClass().getResource(name);
		String name2 = url.toString();
		String name3 = name2.substring(4);
		System.out.println(name2 ) ;
		url.openStream();
		System.out.println(url.getFile());
		
		ZipInputStream zip = new ZipInputStream(url.openStream());
		 java.util.jar.JarFile jf = new java.util.jar.JarFile("/home/rephus/Escritorio/programa/prueba.jar");
		 System.out.println(url.getPath());
		*/
		font = sdljava.ttf.SDLTTF.openFont( name, 20);//TTF_OpenFont(name,20); //cargamos la font
		
	}
	
	/*void setzoom(TextSize size){
		font.sizeText("hola", size);
		
		//sdljava.ttf.SDLTTF.openFont
		
	}*/
	
	void setcolor(int r,int g, int b){
		
		fgcolor.setBlue(b);
		fgcolor.setRed(r);
		fgcolor.setGreen(g);
	}

	void drawtext(String msg,SDLSurface screen,double x, double y) throws SDLException{

		//sprintf(text,"%s", msg);		//copia el texto a la cadena

		ttext = font.renderTextBlended(msg,  fgcolor);//sdljava.ttf.SDLTrueTypeFont.renderTextShaded(msg, fgcolor, bgcolor);
		
		/*
		rectangle.y=(int) y;		//creamos el rectangle que va a incluir el texto
		rectangle.x=(int) x;
		rectangle.width=ttext.getWidth();	//asignamos el ancho y alto del texto
		rectangle.height=ttext.getHeight();
*/
		//SDL_FillRect(screen,&rectangle,SDL_MapRGB(screen->format,0,0,0)); //borramos el texto atnerior

		//SDL_SetColorKey(ttext,sdljava.video.SDLVideo.SDL_SRCCOLORKEY, sdljava.video. (ttext->format,0,0,0));  // Asignamos el texto transparente al color verde.|SDL_RLEACCEL

	     //(ttext,screen);// (ttext,null,screen,rectangle); //pintamos texto
		SDLRect textpos = new SDLRect(0, 0);
		textpos.x = (int) x;
		textpos.y = (int) y;
	//	System.out.println(screen);
	//	System.out.println(textpos);
		ttext.blitSurface(screen, textpos);
		//ttext.freeSurface();
		
		//SDL_FreeSurface( ttext );

	}
	
	public void setZoom(int z) throws SDLException{
		
		size = z ;
		//String path  = font.getPath()  ;
		/*sdljava.ttf.TextSize size = new TextSize() ;
		size.setHeight(5);
		size.setWidth(20);
		System.out.println( size.getHeight() );
		//System.out.println(font.sizeText("hola") ) ;
		System.out.println(font.sizeText("hola", size) );
		
		font.setFontStyle(sdljava.ttf.SDLTrueTypeFont.TTF_STYLE_UNDERLINE);
		System.out.println(font.getPTSize() );
		*/
		//font.closeFont();
		//font = sdljava.ttf.SDLTTF.openFont(path, 30);
		//font.closeFont();
		
		//font = null ;
		font = sdljava.ttf.SDLTTF.openFont(path, z);//TTF_OpenFont(name,20); //cargamos la font
	
		//font.closeFont();
		//font.sizeText("hola", size);
		//font = sdljava.ttf.SDLTTF.openFont(path, z);
		
	}
	public void setFont(String path) throws SDLException{
		
		font = sdljava.ttf.SDLTTF.openFont(path, size);
		
	}
	
}
